package dev.shadowsoffire.apotheosis.adventure.compat;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.google.common.base.Predicates;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import java.util.function.Predicate;
import net.minecraft.core.registries.Registries;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.PathfinderMob;
import net.minecraft.world.entity.ai.goal.AvoidEntityGoal;
import net.minecraft.world.entity.ai.goal.Goal;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.Item;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.entity.EntityJoinLevelEvent;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.registries.RegistryObject;
import twilightforest.entity.monster.Redcap;

public class AdventureTwilightCompat {
  protected static final RegistryObject<Item> ORE_MAGNET = RegistryObject.create(new ResourceLocation("twilightforest", "ore_magnet"), Registries.f_256913_, "apotheosis");
  
  protected static final RegistryObject<EntityType<Redcap>> REDCAP = RegistryObject.create(new ResourceLocation("twilightforest", "redcap"), Registries.f_256939_, "apotheosis");
  
  public static void register() {
    GemBonus.CODEC.register(Apotheosis.loc("twilight_ore_magnet"), OreMagnetBonus.CODEC);
    GemBonus.CODEC.register(Apotheosis.loc("twilight_treasure_goblin"), TreasureGoblinBonus.CODEC);
    GemBonus.CODEC.register(Apotheosis.loc("twilight_fortification"), FortificationBonus.CODEC);
    MinecraftForge.EVENT_BUS.addListener(dev.shadowsoffire.apotheosis.adventure.compat.AdventureTwilightCompat::doGoblins);
  }
  
  @SubscribeEvent
  public static void doGoblins(EntityJoinLevelEvent e) {
    Entity entity = e.getEntity();
    if (entity instanceof Redcap) {
      Redcap r = (Redcap)entity;
      if (r.getPersistentData().m_128441_("apoth.treasure_goblin")) {
        r.f_21346_.m_262460_((Predicate)Predicates.alwaysTrue());
        r.f_21345_.m_262460_((Predicate)Predicates.alwaysTrue());
        r.f_21345_.m_25352_(10, (Goal)new AvoidEntityGoal((PathfinderMob)r, Player.class, 6.0F, 1.0D, 1.25D));
      } 
    } 
  }
}
